/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!WIN-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Accessoires!
// Dfinition du module        !CONFIG!=/V4!Gestion Configuration!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | WIN-CPC                 | Accessoires
* ------------------------------------------------------------------------------
*  Fichier     : CONFIG.C              | Version : 0.1x
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dcodage du fichier de configuration
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  06/01/2003              | L.DEPLANQUE             | Version 0.1t : Gestion
*                          |                         | nouvelles variables :
*                          |                         | localisation des roms
* ------------------------------------------------------------------------------
*  09/01/2003              | L.DEPLANQUE             | Version 0.1u : Gestion
*                          |                         | nouvelles variables :
*                          |                         | touches joystick
* ------------------------------------------------------------------------------
*  03/02/2003              | L.DEPLANQUE             | Version 0.1v : Gestion
*                          |                         | nouvelles variables :
*                          |                         | localisation fichiers
*                          |                         | DSK, SNA, TAP
* ------------------------------------------------------------------------------
*  06/05/2003              | L.DEPLANQUE             | Version 0.1w :
*                          |                         | Initialisation des
*                          |                         | valeurs par dfaut pour
*                          |                         | les variables contenant
*                          |                         | les scan-codes des
*                          |                         | touches mulant le
*                          |                         | joystick
* ------------------------------------------------------------------------------
*  22/01/2004              | L.DEPLANQUE             | Version 0.1x : Gestion
*                          |                         | nouvelle variable :
*                          |                         | localisation rpertoire
*                          |                         | emulation disque
* ------------------------------------------------------------------------------
*  03/02/2004              | L.DEPLANQUE             | Version 0.1y : 
*                          |                         | Suppression des
*                          |                         | fonctions de lecture
*                          |                         | des variables de type
*                          |                         | paramtres, et passage
*                          |                         | de ces variables en
*                          |                         | variables globales.
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <stdlib.h>
#include  <string.h>
#include  <stdio.h>

#include  "types.h"


#define     CONFIG_NAME     "CONFIG.CPC"



/********************************************************* !NAME! **************
* Nom : Sound
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Son ou non
*
********************************************************** !0! ****************/
int Sound = 1;


/********************************************************* !NAME! **************
* Nom : Multiface
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Multiface active ou non
*
********************************************************** !0! ****************/
int Multiface = 1;


/********************************************************* !NAME! **************
* Nom : LogLevel
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Niveau de logging
*
********************************************************** !0! ****************/
int LogLevel = 3;


/********************************************************* !NAME! **************
* Nom : JoyLeft
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick direction gauche
*
********************************************************** !0! ****************/
int JoyLeft = 0xFF;


/********************************************************* !NAME! **************
* Nom : JoyRight
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick direction droite
*
********************************************************** !0! ****************/
int JoyRight = 0xFF;


/********************************************************* !NAME! **************
* Nom : JoyUp
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick direction haut
*
********************************************************** !0! ****************/
int JoyUp = 0xFF;


/********************************************************* !NAME! **************
* Nom : JoyDown
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick direction bas
*
********************************************************** !0! ****************/
int JoyDown = 0xFF;


/********************************************************* !NAME! **************
* Nom : JoyFire1
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick bouton feux 1
*
********************************************************** !0! ****************/
int JoyFire1 = 0xFF;


/********************************************************* !NAME! **************
* Nom : JoyFire2
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Scan code de touche mulant joystick bouton feux 2
*
********************************************************** !0! ****************/
int JoyFire2 = 0xFF;


/********************************************************* !NAME! **************
* Nom : DirSnap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers snapshots
*
********************************************************** !0! ****************/
char DirSnap[ 256 ] = "..\\Snap";


/********************************************************* !NAME! **************
* Nom : DirTape
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers cassettes
*
********************************************************** !0! ****************/
char DirTape[ 256 ] = "..\\Tape";


/********************************************************* !NAME! **************
* Nom : DirDisc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers disquettes
*
********************************************************** !0! ****************/
char DirDisc[ 256 ] = "..\\Disc";


/********************************************************* !NAME! **************
* Nom : DirEmuDisc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire servant  l'mulation disque
*
********************************************************** !0! ****************/
char DirEmuDisc[ 256 ] = "A:";



/********************************************************* !NAME! **************
* Nom : ReadConfig
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Lecture du fichier config. et affectation des variables
*               concernes
*
* Rsultat    : TRUE si lecture fichier config. OK, FALSE sinon
*
* Variables globales modifies : FrameSkip, Sound, 
*                                Multiface, LogLevel
*                                JoyLeft, JoyRight, JoyUp, JoyDown, JoyFire1,
*                                JoyFire2, DirSnap, DirTape, DirDisc
*
********************************************************** !0! ****************/
BOOL ReadConfig( void )
{
    Sound = 1;
    return( TRUE );
}
